/******************************************************************************

1. 首先引入zaf.js文件
<script src="zaf.js"></script>

2. js中直接使用zaf这个全局对象调用native方法

// 调用native的方法，参数传递都是json对象或者没有参数
// 回调函数一般也是json对象，或者普通变量（如string，number）
zaf.getUserInfo({
  'success': function(userInfo) { // 返回值为json对象
	console.log(userInfo.username);
  },
  'fail': function() { // 无返回值
    console.log("fail");
  }
});

// 直接调用，无参数传递
zaf.close();

******************************************************************************/


(function() {
	
	// deep copy an object
	var cloneObj = function(obj) {
    var str, newobj = obj.constructor === Array ? [] : {};
    if(typeof obj !== 'object'){
        return;
    } else if(window.JSON){
        str = JSON.stringify(obj), //系列化对象
        newobj = JSON.parse(str); //还原
    } else {
        for(var i in obj){
            newobj[i] = typeof obj[i] === 'object' ? 
            cloneObj(obj[i]) : obj[i]; 
        }
    }
    return newobj;
	};

	// Bridge interface to SDK
	var bridge = window.bridge = {
		nativeSDKFiredReady: true,
		nativeCallInFlight: false,
		nativeCallQueue: [],
		callbacks: []
	};
	
	var CALLBACK_ID = 1;
	
	// Native 调用 JS, 主要为callback
	bridge.invokeJs = function(res) {
		console.log(res);
		var result = JSON.parse(res);
		var callbackId = result.callbackId;
		var func = this.callbacks[callbackId];
		var args = [];
	
		if (typeof result.response != 'undefined') {
			var response = result.response;
			args.push(response);
		}
		func.apply(this, args);
	};
  
	/** JS 调用 Native
	 * @param name The function name
	 * @param params The JSON Object
	 */
	bridge.invokeNative = function() {
		var args = Array.prototype.slice.call(arguments);
		var name = args.shift(); // the function name to invoke
		var params = args.shift(); // the params with JSON Object
		var newParams = {};
		
		if (typeof params != 'undefined') {
			newParams = cloneObj(params);
		
			if (typeof params.success === 'function') {
				var callbackId = CALLBACK_ID++;
				this.callbacks[callbackId] = params.success;
				newParams.success = callbackId;
			}
	
			if (typeof params.fail === 'function') {
				var callbackId = CALLBACK_ID++;
				this.callbacks[callbackId] = params.fail;
				newParams.fail = callbackId;
			}
		}
	
		var call = 'yywj://jsbridge?method=' + name + '&params='  + encodeURIComponent(JSON.stringify(newParams));
		console.log(call);
		
		if (this.nativeCallInFlight) {
			this.nativeCallQueue.push(call);
		} else {
			this.nativeCallInFlight = true;
			window.location = call;
		}
		
	};
	
	bridge.nativeCallComplete = function(command) {
		if (this.nativeCallQueue.length === 0) {
			this.nativeCallInFlight = false;
			return;
		}

		var nextCall = this.nativeCallQueue.pop();
		window.location = nextCall;
	};
  
	// JS调用Native的方法
	var zaf = window.zaf = {};
	
	// 未登录时跳转登录,已登录
	zaf.goLogin = function(params) {
		bridge.invokeNative('goLogin', params);
	};

	//商城跳转登录使用
    zaf.login = function(params) {
    	bridge.invokeNative('goLogin', params);
    };

    //商城中心
    zaf.jumpUserCenter = function(params) {
    	bridge.invokeNative('mallMine', params);
    };

    // 获取用户信息
    zaf.getUserInfo = function(params) {
    	bridge.invokeNative('getUserInfo', params);
    };

    // 获取公共参数信息
    zaf.getPubParams = function(params) {
        bridge.invokeNative('getPubParams', params);
    };


    // 邀请分享
    zaf.inviteShare = function(params) {
        bridge.invokeNative('inviteShare', params);
    };

    // 芝麻回调
    zaf.callBackZhimaScore = function(params) {
        bridge.invokeNative('callBackZhimaScore', params);
    };

    //
     zaf.callBackTaoBao = function(params) {
            bridge.invokeNative('callBackTaoBao', params);
        };

     zaf.callBackEdu = function(params) {
                bridge.invokeNative('callBackEdu', params);
            };

    // 分享
    zaf.share = function(params) {
        bridge.invokeNative('share', params);
    };

    // 分享到微信好友
    zaf.share2WXFriend = function(params) {
        bridge.invokeNative('share2WXFriend', params);
    };

    // 分享到微信朋友圈
    zaf.share2WXCircle = function(params) {
        bridge.invokeNative('share2WXCircle', params);
    };

    // 分享到QQ好友
    zaf.share2QQFriend = function(params) {
        bridge.invokeNative('share2QQFriend', params);
    };

    // 分享到QQ空间
    zaf.share2QQZone = function(params) {
        bridge.invokeNative('share2QQZone', params);
    };

    // 分享到微博
    zaf.share2Weibo = function(params) {
        bridge.invokeNative('share2Weibo', params);
    };

    // 设置导航条右上角按钮文字
    zaf.setRightNaviItem = function(params) {
        bridge.invokeNative('setRightNaviItem', params);
    };

    // 隐藏导航条右上角按钮
    zaf.hideRightNaviItem = function(params) {
        bridge.invokeNative('hideRightNaviItem', params);
    };

    //收银台
    zaf.cashier = function(params) {
        bridge.invokeNative('cashier', params);
    };

    // 获取联系人
    zaf.getAddressBook = function(params) {
    	bridge.invokeNative('getAddressBook', params);
    };

    // 闪付活动模版分享
    zaf.setRightNaviImage = function(params) {
    	bridge.invokeNative('setRightNaviImage', params);
    };


	// 拍照
    zaf.openCamera = function(params) {
    	bridge.invokeNative('openCamera', params);
    };

    // 拍视频
    zaf.shootVideo = function(params) {
       bridge.invokeNative('shootVideo', params);
    };

    //webActivity 打开
    zaf.openWebView = function(params) {
    	bridge.invokeNative('openWebView', params);
    };

    //支持打开Native相关页面
    zaf.jumpPage = function(params) {
    	bridge.invokeNative('jumpPage', params);
    };

    //支持打开Native相关页面
    zaf.getContractInfo = function(params) {
    	bridge.invokeNative('getContractInfo', params);
    };
    //关闭当前Web页面
    zaf.close = function (params) {
        bridge.invokeNative("close");
      };

    //调起云闪付
    zaf.callUPPayment = function (params) {
        bridge.invokeNative('callUPPayment');
    };

    //返回
    zaf.goBack = function (params) {
        bridge.invokeNative('goBack');
    };

    //返回设置
    zaf.backSetting = function (params) {
        bridge.invokeNative('backSetting', params);
    };

}());
